#pragma once
#include "IModule.h"
#include <list>
#include <map>
#include "Item.h"


class OSTPPKGameModule :
	public IModule
{
public:
	OSTPPKGameModule(IProxy* proxy);
	~OSTPPKGameModule();

	void _stdcall OnRelayDataToServer(IPacket* packet, const IModule* owner);
	void _stdcall OnRelayDataToClient(IPacket* packet, const IModule* owner);
	void _stdcall Update();
	void _stdcall Destroy();

private:

	enum ChickenState
	{
		ChickenState_InTown,
		ChickenState_Ready,
		ChickenState_OpeningTp,
		ChickenState_UsingTp
	};

	struct Player
	{
		char name[16];
		int level;
		int id;
		bool isHostile;
		int xPos;
		int yPos;
	};


	void CastTp();
	void UsePortal(int portalId);
	void UseObject(int objectType, int objectId);
	void InvInteract(int objectId);
	void UseRightSkillOnObject(int objectType, int objectId);
	void UseLeftSkillOnObject(int objectType, int objectId);
	void Chat(const char* name, bool whisper, const char* format, ...);
	void AddPlayer(const char* playerName, int playerLevel, int playerId);
	void RemovePlayer(const char* playerName);
	void HostilePlayer(int playerId);
	void HostileParty();


	const char* _chatName;
	item TownPortalBook;
	int currentIter;
	bool _hostile;
	int _currentTarget;
	std::list<Player> _players;	
	IProxy* _proxy;
	Player _hero;
	ChickenState _state;
};
